# 挥码枪上手指南
## 欢迎您使用挥码枪!
挥码枪是基于ARM CoreSight技术的硬件调试器，其核心功能是通过CoreSight协议访问目标系统，实现系统调试和调优等功能；您收到的盒子中包括如下部件：
- 挥码枪核心硬件（主板、微处理器等）
- USB线一根及SD转接卡和连线一套
- 透明塑料包装盒一个
- 说明书一份

## 上手步骤
1.下载Nano Code调试工具。
https://www.nanocode.cn/#/download
2.按下图所示，将SD转接卡与挥码枪连接。
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_d788d8a815e0852dc891f2b09dadc115_r.png)
3.将转接卡插入GDK8，USB线插入上位机。
4.**[此步骤仅对老GDK8必须操作]**开启GDK8的JTAG，可以通过GDK8的葫芦娃小程序或者遥控器按[Fn+5]进行切换**(7月20号之后的GDK8默认是开启JTAG的，此步额外操作，会关闭JTAG功能，导致调试时出项-4错误（读IDR寄存器失败）。)**
5.打开Nano Code，进入Nano调试；未注册用户，请先注册账号。
6.点击 [内核调试]，点击 [USB2/USB3]，选择 [OpenOCD] [Reconnect] [Linux Kernel] [Memory Shadow]，点击 [启动]，等待调试会话的建立；如下图所示。
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_9aed48ca63be9b072f548796b26d1a60_r.png)
7.点击工具栏上的中断按钮，发起中断。
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_a36e4f8557437520107783964d3cf6a9_r.png)
8.如果看到下图所示的命令提示符，则代表成功建立内核调试会话，可以通过CoreSight技术来探索ARMv8和Linux内核的世界了。
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_1b57f2d4eefb684089125439cd69a66b_r.png)
9.如果调试时遇到意外情况，建议点击View > Output唤出Output面板，在面板上的信息源下拉框中选择“Nano Code”。