# 理解NDB的内核地标机制

地标，这是NDB找到Linux内核的地标：
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_901344080c2507c17bbcbd48b584fcca_r.png)

marker 到底有啥，dq：
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_d0dceb132ec7be9c65924103677433d0_r.png)

NDP_MARKER_A & NDP_MARKER_B
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_0f25b20ea386b00787f745990f7f7a4f_r.png)

原来还有彩蛋，这可是张老师亲自确认的哈：
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_d77c95c5e3a445b817bab7b79f1d27a2_r.png)

GEDU
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_8a5c1a332e68481bda932f74ee254d00_r.png)

源代码中的数据结构：
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_1993d48259e8f24e2203c03e83ab8291_r.png)

此数据结构的初始化：
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_6561688a1ac719159c86b444cfabcc45_r.png)

再上dqs看有什么相关的符号？
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_5bc2be80bf8f31c8a3c940f1204f108f_r.png)

File copy task is sent to NdSrv via mailbox /usr/lib/debug/.build-id/6f/01e81d8f1d44e4c926ba0739e1d5b722019973.debug 1.
Please execute a 'g' command so that NdSrv can run and serve the file request.
暂试执行了g命令，然后断下，未发现有/usr/lib/debug/.build-id/6f/ 文件夹。
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_f8d5b69d11e98f364d5c34142f5727fc_r.png)

调试器符号文件夹发现之前的一个记录，但没有文件
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_ed2ba0a3075a3e0ccc88033ad3880cd2_r.png)

麻烦些，手动对照，参考IDA可加载头文件定义结构或手动自定义结构，然后dt，那将帅呆了：
（2022.07.11 其实就是缺ndb.ko到NanoCode的符号文件夹，请跳到下面 2022.07.11 update）：
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_13b93e1eb83819229e5b8b84616b556d_r.png)

即使暂时没有在NDB中加载到ndb.ko的符号，但是仍然可以从下面的方式获取一些符号信息的：
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_7ba993daaeb62310acf0e8eef30bc975_r.png)

ffffff80012e6470 t kgb_init	[ndb] 试下反汇编此地址：
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_0dfef2b9b7c09f7f1aad504c006114c2_r.png)

![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_560b36b3412634e5749521ba01bdd2e4_r.png)
调用 alloc_pages_node，对上源代码了：
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_f6999ad31dd9a5d44bcf1d6cc59e7911_r.png)

有了底层把握到每个字节、寄存器等的基础能力，上层调试、分析的高级功能可尽情地发挥想象。

期待中



------------


2022.07.11 update

根据昨天张老师课上的提示，终于看到了心心念念想要的结果：
It is so beautiful!
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_0e5b486713b8b0d043d6c795ee2a6514_r.png)

![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_5cad5c54d86b1871bfbb29b2899e2249_r.png)
Much more than "lm" output, actually you can get everything/every bit with NDB. Lovely