# NDB 的调试命令示例

2022.07.08
在NDB的调试命令行输入 ？可以显示调试命令的帮助。
Nano Debugger (NDB) 1.8.898 (7952:9648)
输出如下：
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_25f92b6970f9b42b8dcd2e83f1165da0_r.png)

比如s 搜索指令，要注意字节序列，比如下面源代码定义从高位往低位读是“GEDU”:
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_c2c03b436aef696baaaef9668bfbcc0a_r.png)

但在内存中，从低到高输出序列是：UDEG:
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_bc3a9ba7a3073acf1d20d08fc386db81_r.png)

还有些windbg兼容的命令，不在上面的帮助中，可以直接用，用法可以在windbg帮助文档中查找，下面举几个例子：
关于符号：
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_6f8ae7056f93e441d65821cf431a06cf_r.png)

dqs 当前调用栈：
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_bf13e8fefb86d7bcb152f2952a3ac303_r.png)

.formats：
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_8c5d0b5b71a575509329aa41020ec873_r.png)

单步及源码显示控制：
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_e29df5f726a890f4c77593c0cb8dcc46_r.png)

. 在指令中代表当前pc：
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_f8087d847e598bc4ef0bd9b0bb658ed8_r.png)

有些gdb的命令也可以直接用，比如：
bt，将被翻译成kPn再执行：
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_425a779420b7725a8ad4b9fa9274db6d_r.png)

C:\NanoCode\data\cmdmap.txt 命令映射也是个参考：
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_62bf9770622017c39b5cd609a088a215_r.png)

所以，帮助里还没有提及的调试命令，或可以试下windbg、gdb的命令，说不定可以直接用。