>   飞腾腾珑E2000系列包括E2000Q、E2000D、E2000S三个系列，芯片集成飞腾自主研发的高能效和低功耗处理器核，E2000Q集成2个FTC664和2个FTC310处理器核，E2000D集成2个FTC310处理器核，E2000S集成1个FTC310处理器核，兼容64位ARMv8指令集并支持ARM64和ARM32两种执行模式，支持单精度、双精度浮点运算指令和ASIMD处理指令，支持硬件虚拟化，产品支持商业和工业分级。         （来自飞腾官网）

在本篇文档将介绍如何使用挥码枪调试**飞腾E2000Q**

## 一. 准备材料：
- JTAG 10针接头线
- 安装好Nano Code的调试主机(我这里使用的是Windows版Nano Code)
- 飞腾E2000Q开发板或者整机（需要有jtag口）

## 二. 连接：
#### 2.1 将印有NTP的面朝上和挥码枪连接，如下图所示：
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_25a83a40b16bdf9de47168346f0e9b8b_r.jpeg)

#### 2.2 将印有JTAG的所在面冲板子内侧连接起来，如下图所示：
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_68cee9e5e93babade4897ae15ea84f82_r.png)

#### 2.3 然后就是将挥码枪另一端Type C使用Type C转usb线连接到安装有Nano Code的调试主机上

### 附：飞腾E2000Q与挥码枪针脚对应关系
在飞腾E2000Q的背面，我们可以看到上面已经标记好了相关的针脚名，同样，在挥码枪背面，也标注了挥码枪对应的针脚名。

| 飞腾  | 挥码枪  |
| ------------ | ------------ |
|  TMS |  SWD |
|  TCK |  SWK |
|  TDO | TDO  |
|   TDI|   SWDIO|
|   RST| SWCLK  |
|GND|GND|

## 三. 调试：
在首次下载[Nano Code](https://www.nanocode.cn/#/nanocode/index-1 "Nano Code")安装后，需要先点击右下方的插件，更新到当前最新版，我这里是是2.7.52
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_d1a35bee8a6f67a14883e2f81d86fcda_r.png)
更新完成后，点击"内核调试",然后选中"OpenOCD",然后下面输入"e2000”，按照下图所示，进行勾选上，确认无误后，就可以点击“启动”

![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_4626ff4977a62e23f458236e3979b751_r.png)

如果接线正确的话，可以看到下图类似内容：
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_cb5f1e7948145f850d12de06fa3fbb6c_r.png)
此时，我们点击上面的中断按钮，然后就可以在下面输入框输入命令，例如我这里输入的命令是r
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_c912e06b61f295a79630de55e9589cdf_r.png)
到此为止，我们就可以根据自己的需要进行调试飞腾E2000Q了