# NTP升级过程详细说明：
1. 准备工作：

- 确保你有两个NTP（Nano Target Probe）设备，需要升级其中一个。
- 准备好串口连接线，用于连接电脑NTP设备。引脚连接说明：
  -  SWK（TOP SIDE）—— 连接到被升级的NTP端的SWCLK引脚。(BOTTOM SIDE）
  - SWD（TOP SIDE）—— 连接到被升级的NTP端的SWDIO引脚。(BOTTOM SIDE）
 - GND（TOP SIDE）—— 连接到被升级的NTP端的GND引脚。(BOTTOM SIDE）
 - 3V3（BOTTOM SIDE） ——— 3V3 (BOTTOM SIDE）
- 将NTP设备的USB端口连接到电脑上.**（被烧录的ntp的usb口不需要连接）**
下图示例：
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_21f75935c155fd2f2f399064c9bf124a_r.jpeg)
2. 打开NanoCode：

- 打开NanoCode软件，在内核调试界面选择"openocd"，找到一个输入框或命令行，输入gdk3(如下图所示)。
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_b9ec42fc9ee2e4af934252b96afe4d20_r.png)

3. 连接NTP设备：

- 输入设备名称后点击**启动**按钮即可。连接成功后，你会看到如下提示表明设备已连接。
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_c23d6a15432a45524e55e6eea7bbfc75_r.png)
4. 点击中断按钮：

- 在NanoCode界面上找到一个名为"中断"的按钮，点击它。
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_695e19ea4a6ea4237a9aed44a8432ccb_r.png)
5. 烧录操作：

- 在NanoCode的命令行或输入框中输入以下命令：
```bash
!program PATH
```
这里的PATH是你下载好的NTP固件（通常是.hex文件）的路径。本文结尾下载ntp文件附件，去掉后缀名.txt 
下图示例：
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_1fbae30e71880a32a2fa4104c70c2920_r.png)
本示例中命令为```
!program D:\\ntp.hex
```
- 输入完命令后，按下回车键执行。NanoCode将会开始烧录NTP固件到你连接的设备中
6. 完成：

- 一旦烧录完成，你会收到如下图的提示，表示NTP设备已成功升级。
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_4a4bfec4dcb761aba8fb3ac1664bc966_r.png)
- 断开串口连接，关闭NanoCode软件，你现在可以重新连接你的NTP设备并测试新的固件了。