# 葫芦娃中的SysRq相关的一些信息
2022.07.09

如果开启了SysRq功能，每次调试完可以用遥控器关机，就非常方便，用 (3Fn + 5)，按三次Fn键然后按一次5。

葫芦娃中支持的SysRq功能有：
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_8bbb4f2a1cbbc0260115f5052d874595_r.png)
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_41906e4d04ccef3dc1baeec756468e16_r.png)
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_2e2567a4b81766366101bb46bd6c7648_r.png)

不过，暂时葫芦娃1.1版本切换SysRq还无效，只能通过遥控器按Fn+4在gird中切换，葫芦娃的按键状态暂未与gird中的实际状态进行同步：

遥控器Fn + 4 -> LED: F401，普通模式也执行SysRq指令：
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_03a27961e1e1ff09cd608a9100911c36_r.png)

Fn + 4 -> LED: F400, SysRq模式也不执行SysRq指令：
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_75904f8702c18ddeeba84510a4eefaaf_r.png)

具体情况，可以在root权限上gdb跟踪：
sudo gdb attach (gird pid)
b write_sysrq
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_c7b87b7b48f7a852e3e949cbd6c2d9f3_r.png)

查看系统中SysRq的真实状态，分别对应LED 显示 F400与F401：
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_3ace7752f0422c782d102e112efc135e_r.png)

当然，最底层的动作其实如下，向/proc/sysrq-trigger写命令（头两个命令l p暂时无输出）：
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_7e689f15c4b06e48353ac9cda9ddadf2_r.png)
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_fc31c4a13ae2cdae52dbe562dc5ffb53_r.png)
![](https://www.nanocode.cn/wiki/uploads/gedu_ntp_wiki/images/m_21f0aa5cbdf9e5073a7654e6bde6857e_r.png)

有兴趣可以到内核源代码中看具体是如何实现的。